/* list.h */
/* $Id: ptxlist.h,v 1.4 2003/11/03 18:57:18 bsp Exp $ */
/* ... */

#ifndef LIST_H
# define LIST_H
# ifdef __cplusplus
extern "C" 
{
# endif
	
	typedef struct ptxlist 
	{
		struct ptxlist	*prev;
		struct ptxlist	*next;
		void		*data;
	} ptxlist;
	
	typedef struct ptxtree
	{
		struct ptxtree  *prev;
		struct ptxtree  *next;
		struct ptxtree  *up;
		struct ptxtree  *down;
		void            *data;
	} ptxtree;
	
	/* list */
	ptxlist *list_init (void);
	void goto_head (ptxlist **l);
	void goto_tail (ptxlist **l);
	void goto_prev (ptxlist **l);
	void goto_next (ptxlist **l);
	int is_last (ptxlist *l);
	int is_empty (ptxlist *l);
	int is_first (ptxlist *l);
	ptxlist *list_add_after (ptxlist *l, void *data, size_t size);
	ptxlist *list_add_head (ptxlist *l, void *data, size_t size);
	ptxlist *list_add_tail (ptxlist *l, void *data, size_t size);
	ptxlist *list_del (ptxlist *l);
	ptxlist *list_del_element (ptxlist *l);
	ptxlist *list_find (ptxlist *l, int (*fnct) (void *, void *), void *test);
	void *list_get_element_data (ptxlist *l);
	
	/* tree */
	ptxtree *init_tree (void *data, size_t size);
	void goto_root (ptxtree **t);
	void goto_parent (ptxtree **t);
	void goto_child (ptxtree **t);
	void goto_prev_sibling (ptxtree **t);
	void goto_next_sibling (ptxtree **t);
	void goto_first_sibling (ptxtree **t);
	void goto_last_sibling (ptxtree **t);
	void goto_first_child (ptxtree **t);
	void goto_last_child (ptxtree **t);
	int is_root (ptxtree *t);
	int is_first_sibling (ptxtree *t);
	int is_last_sibling (ptxtree *t);
	ptxtree *add_sibling (ptxtree *t, void *data, size_t size);
	ptxtree *add_child (ptxtree *t, void *data, size_t size);
	ptxtree *del_tree_element (ptxtree *t);
	void del_tree (ptxtree *t);
	void *get_tree_element_data (ptxtree *l);
	
# ifdef __cplusplus
}
# endif
#endif /* LIST_H */
